RouterRpcMonitor (Apache Hadoop HDFS-RBF 3.5.0 API)
Description: declaration: package: org.apache.hadoop.hdfs.server.federation.router, interface: RouterRpcMonitor

Package org.apache.hadoop.hdfs.server.federation.router

# Interface RouterRpcMonitor

All Known Implementing Classes:
  `FederationRPCPerformanceMonitor`

public interface RouterRpcMonitor
Metrics and monitoring interface for the router RPC server. Allows pluggable diagnostics and monitoring services to be attached.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Close the monitor.
  `FederationRPCMetrics`
  `getRPCMetrics()`
  Get Router RPC metrics info.
  `void`
  `init(org.apache.hadoop.conf.Configuration conf, RouterRpcServer server, StateStoreService store)`
  Initialize the monitor.
  `long`
  `proxyOp()`
  Start proxying an operation to the Namenode.
  `void`
  `proxyOpComplete(boolean success, String nsId, FederationNamenodeServiceState state)`
  Mark a proxy operation as completed.
  `void`
  `proxyOpFailureClientOverloaded()`
  Failed to proxy an operation to a Namenode because the client was overloaded.
  `void`
  `proxyOpFailureCommunicate(String nsId)`
  Failed to proxy an operation to a namenode because of an unexpected exception.
  `void`
  `proxyOpFailureStandby(String nsId)`
  Failed to proxy an operation to a namenode because it was in standby.
  `void`
  `proxyOpNoNamenodes(String nsId)`
  Failed to proxy an operation because of no namenodes available.
  `void`
  `proxyOpNotImplemented()`
  Failed to proxy an operation because it is not implemented.
  `void`
  `proxyOpPermitAccepted(String nsId)`
  Accepted to proxy an operation to a namenode.
  `void`
  `proxyOpPermitRejected(String nsId)`
  Rejected to proxy an operation to a namenode.
  `void`
  `proxyOpRetries()`
  Retry to proxy an operation to a Namenode because of an unexpected exception.
  `void`
  `routerFailureLocked()`
  If a path is locked.
  `void`
  `routerFailureReadOnly()`
  If a path is in a read only mount point.
  `void`
  `routerFailureSafemode()`
  If the Router is in safe mode.
  `void`
  `routerFailureStateStore()`
  If the Router cannot contact the State Store in an operation.
  `void`
  `startOp()`
  Start processing an operation on the Router.

- ## Method Details

  - ### init

    void init(org.apache.hadoop.conf.Configuration conf, RouterRpcServer server, StateStoreService store)
    Initialize the monitor.
    Parameters:
      `conf` - Configuration for the monitor.
      `server` - RPC server.
      `store` - State Store.

  - ### getRPCMetrics

    FederationRPCMetrics getRPCMetrics()
    Get Router RPC metrics info.
    Returns:
      The instance of FederationRPCMetrics.

  - ### close

    void close()
    Close the monitor.

  - ### startOp

    void startOp()
    Start processing an operation on the Router.

  - ### proxyOp

    long proxyOp()
    Start proxying an operation to the Namenode.
    Returns:
      id of the thread doing the proxying.

  - ### proxyOpComplete

    void proxyOpComplete(boolean success, String nsId, FederationNamenodeServiceState state)
    Mark a proxy operation as completed.
    Parameters:
      `success` - if the operation was successful.
      `nsId` - nameservice id.
      `state` - namenode state in the federation.

  - ### proxyOpFailureStandby

    void proxyOpFailureStandby(String nsId)
    Failed to proxy an operation to a namenode because it was in standby.
    Parameters:
      `nsId` - nameservice id.

  - ### proxyOpFailureCommunicate

    void proxyOpFailureCommunicate(String nsId)
    Failed to proxy an operation to a namenode because of an unexpected exception.
    Parameters:
      `nsId` - nameservice id.

  - ### proxyOpPermitRejected

    void proxyOpPermitRejected(String nsId)
    Rejected to proxy an operation to a namenode.
    Parameters:
      `nsId` - nameservice id.

  - ### proxyOpPermitAccepted

    void proxyOpPermitAccepted(String nsId)
    Accepted to proxy an operation to a namenode.
    Parameters:
      `nsId` - nameservice id.

  - ### proxyOpFailureClientOverloaded

    void proxyOpFailureClientOverloaded()
    Failed to proxy an operation to a Namenode because the client was overloaded.

  - ### proxyOpNotImplemented

    void proxyOpNotImplemented()
    Failed to proxy an operation because it is not implemented.

  - ### proxyOpRetries

    void proxyOpRetries()
    Retry to proxy an operation to a Namenode because of an unexpected exception.

  - ### proxyOpNoNamenodes

    void proxyOpNoNamenodes(String nsId)
    Failed to proxy an operation because of no namenodes available.
    Parameters:
      `nsId` - nameservice id.

  - ### routerFailureStateStore

    void routerFailureStateStore()
    If the Router cannot contact the State Store in an operation.

  - ### routerFailureSafemode

    void routerFailureSafemode()
    If the Router is in safe mode.

  - ### routerFailureLocked

    void routerFailureLocked()
    If a path is locked.

  - ### routerFailureReadOnly

    void routerFailureReadOnly()
    If a path is in a read only mount point.